## libgdf 0.1.1

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 2.8 )
#project( GDF )

option( BUILD_TESTING "Build tests" OFF )

if( WIN32 )
	set( BUILD_SHARED_LIBS false CACHE BOOL "Wether we shall build shared or dynamic libraries." )
else( WIN32 )
	set( BUILD_SHARED_LIBS true CACHE BOOL "Wether we shall build shared or dynamic libraries." )
endif( WIN32 )

set( GDF_SOURCE_ROOT ${Project_SOURCE_DIR} )

add_subdirectory( libgdf )
add_subdirectory( tools )

# shared library API versioning (soversion) -- NOT the same as the release version
# it follows first number
set(GDF_VERSION "0.1.1")
string( REGEX MATCH "^[0-9]+" GDF_SHAREDLIB_SOVERSION ${GDF_VERSION})

set_target_properties(GDF PROPERTIES
	VERSION ${GDF_VERSION}
	SOVERSION ${GDF_SHAREDLIB_SOVERSION})

if (BUILD_TESTING)
	include( CTest )
	enable_testing( )
	add_subdirectory( test )
endif()

=== test/CMakeLists.txt ===
cmake_minimum_required( VERSION 2.8 )
project( gdf_tests )

if( UNIX )
	add_definitions( -Wall -Wextra -pedantic -Werror -fPIC)
elseif( MINGW )
	add_definitions( -Wall -Wextra -pedantic -Werror )
elseif( WIN32 )
	add_definitions( -W3 )
endif( UNIX )

configure_file( config-tests.h.in config-tests.h )

find_package( Boost 1.36.0 COMPONENTS date_time filesystem system program_options )

include_directories(
	../libgdf/include
	${Boost_INCLUDE_DIR}
	${gdf_tests_BINARY_DIR}
)

add_executable( testok testOK.cpp )
target_link_libraries( testok ${Boost_LIBRARIES} GDF )
add_test( NAME testok COMMAND testok )

add_executable( testfail testFail.cpp )
target_link_libraries( testfail ${Boost_LIBRARIES} GDF )
add_test( NAME testfail COMMAND testfail )
set_tests_properties( testfail PROPERTIES WILL_FAIL TRUE )

add_executable( testCreateGDF testCreateGDF.cpp )
target_link_libraries( testCreateGDF ${Boost_LIBRARIES} GDF )
add_test( NAME testCreateGDF COMMAND testCreateGDF )

add_executable( testRWConsistency testRWConsistency.cpp )
target_link_libraries( testRWConsistency ${Boost_LIBRARIES} GDF )
add_test( NAME testRWConsistency COMMAND testRWConsistency )


#add_custom_target( buildtests DEPENDS testCreateGDF testRWConsistency )
#add_custom_target( check COMMAND ${CMAKE_CTEST_COMMAND} DEPENDS buildtests )

=== debian/changelog ===
libgdf (0.1.1-1) unstable; urgency=low

  * Initial release (Closes: #601707)
  * Few post-release upstream bugfixes absorbed into quilt patches:
    - fixed data orientation in the resampling example
    - fixed event channel numbering in gdf_writer
    - fixed event mode 3 handling in the resampling example
  * Depend on matlab-support package for install-time building of Matlab
    extensions

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 04 May 2011 21:29:24 -0400

libgdf (0.1.1~svn62-1) UNRELEASED; urgency=low

  * Fresh upstream snapshot (needed for sigviewer 0.5.0)
  * Patches submitted and adopted upstream:
    - 0001-make-explicit-option-either-to-build-include-tests
    - 0002-testfail-must-fail-so-lets-state-that

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 22 Dec 2010 12:23:40 -0500

libgdf (0.1.0~svn31-1) UNRELEASED; urgency=low

  * Initial packaging

 -- Yaroslav Halchenko <debian@onerussian.com>  Thu, 28 Oct 2010 14:27:26 -0400

## libgdf 0.1.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,7 +16,7 @@
 
 # shared library API versioning (soversion) -- NOT the same as the release version
 # it follows first number
-set(GDF_VERSION "0.1.1")
+set(GDF_VERSION "0.1.2")
 string( REGEX MATCH "^[0-9]+" GDF_SHAREDLIB_SOVERSION ${GDF_VERSION})
 
 set_target_properties(GDF PROPERTIES

=== libgdf/CMakeLists.txt ===
cmake_minimum_required( VERSION 2.8 )
project( GDF )

if( UNIX )
        add_definitions( -Wall -Wextra -pedantic -Werror -fPIC )
elseif( MINGW )
        add_definitions( -Wall -Wextra -pedantic -Werror )
elseif( WIN32 )
        add_definitions( -W3 )
endif( UNIX )

#set( CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${GDF_SOURCE_DIR}/lib )
#set( CMAKE_LIBRARY_OUTPUT_DIRECTORY ${GDF_SOURCE_DIR}/lib )
#set( CMAKE_RUNTIME_OUTPUT_DIRECTORY ${GDF_SOURCE_DIR}/bin )

find_package( Boost REQUIRED )

include_directories(
	${GDF_SOURCE_DIR}/include
	${Boost_INCLUDE_DIR}
)

set( HEADERS 
	include/GDF/ChannelDataBase.h
	include/GDF/ChannelData.h
	include/GDF/Channel.h
	include/GDF/EventHeader.h
	include/GDF/Exceptions.h
	include/GDF/GDFHeaderAccess.h
	include/GDF/HeaderItem.h
	include/GDF/MainHeader.h
	include/GDF/Modifier.h
	include/GDF/pointerpool.h
	include/GDF/Reader.h
	include/GDF/RecordBuffer.h
	include/GDF/Record.h
	include/GDF/SignalHeader.h
	include/GDF/TagHeader.h
	include/GDF/tools.h
	include/GDF/Types.h
	include/GDF/Writer.h
        include/GDF/EventConverter.h
)

set( SOURCES
	src/Channel.cpp
	src/EventHeader.cpp
	src/GDFHeaderAccess.cpp
	src/MainHeader.cpp
	src/Modifier.cpp
	src/Reader.cpp
	src/RecordBuffer.cpp
	src/Record.cpp
	src/SignalHeader.cpp
	src/Types.cpp
	src/Writer.cpp
        src/EventConverter.cpp
)

add_library( GDF ${HEADERS} ${SOURCES} ${Boost_LIBRARIES} )

INSTALL( FILES ${HEADERS} DESTINATION include/GDF )
INSTALL( TARGETS GDF
	RUNTIME DESTINATION bin
	LIBRARY DESTINATION lib
	ARCHIVE DESTINATION lib
)

=== matlab/Makefile ===
#
# build matlab functions using matlab's mex tool
#
# issues:
#	* MEX automatically appends the arch dependent suffix (.mexglx, .mexa64, etc.)
#	  How can we make the Makefile aware of the correct suffix? (Hardcoded for now)
#
#	* The libGDF binaries are put where the user chooses to build the library with cmake.
#	  Putting the binaries into a specific location inside the source tree would probably
#	  be the easiest solution, but is not pretty. (For now the search path is hardcoded to
#	  ../build)
#
#	* Location of matlab installation: How can this be determined?
#


SOURCEDIR = .
OUTDIR = .
OBJDIR = build

MEXSUFFIX = mexa64

GDF_INCLUDE_DIR = -I../libgdf/include
GDF_LIB_DIR = -L../build/libgdf
GDF_LIBS = -lGDF

MATLABROOT = /opt/matlab/R2010b
MATLAB_INCLUDE_DIR = -I$(MATLABROOT)/extern/include

MEXTOOL = $(MATLABROOT)/bin/mex

CXXFLAGS = -c -cxx -O -DNDEBUG
LDFLAGS = 

all: $(OUTDIR)/gdf_reader.$(MEXSUFFIX) $(OUTDIR)/gdf_writer.$(MEXSUFFIX)

clean:
	rm -rf $(OBJDIR) $(OUTDIR)/gdf_reader.$(MEXSUFFIX) $(OUTDIR)/gdf_writer.$(MEXSUFFIX)
	
buildclean:
	rm -rf $(OBJDIR)
	
$(OUTDIR)/gdf_reader.$(MEXSUFFIX): $(OBJDIR)/gdf_reader.o
	$(MEXTOOL) -cxx $(LDFLAGS) $(GDF_LIB_DIR) $(GDF_LIBS) -outdir $(OUTDIR) -output $@ $^
	
$(OUTDIR)/gdf_writer.$(MEXSUFFIX): $(OBJDIR)/gdf_writer.o
	$(MEXTOOL) -cxx $(LDFLAGS) $(GDF_LIB_DIR) $(GDF_LIBS) -outdir $(OUTDIR) -output $@ $^
	
$(OBJDIR)/gdf_reader.o: $(SOURCEDIR)/gdf_reader.cpp
	$(MEXTOOL) $(CXXFLAGS) $(MATLAB_INCLUDE_DIR) $(GDF_INCLUDE_DIR) -outdir $(OBJDIR) $^

$(OBJDIR)/gdf_writer.o: $(SOURCEDIR)/gdf_writer.cpp
	$(MEXTOOL) $(CXXFLAGS) $(MATLAB_INCLUDE_DIR) $(GDF_INCLUDE_DIR) -outdir $(OBJDIR) $^

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -36,6 +36,9 @@
 target_link_libraries( testRWConsistency ${Boost_LIBRARIES} GDF )
 add_test( NAME testRWConsistency COMMAND testRWConsistency )
 
+add_executable( testDataTypes testDataTypes.cpp )
+target_link_libraries( testDataTypes ${Boost_LIBRARIES} GDF )
+add_test( NAME testDataTypes COMMAND testDataTypes )
 
 #add_custom_target( buildtests DEPENDS testCreateGDF testRWConsistency )
 #add_custom_target( check COMMAND ${CMAKE_CTEST_COMMAND} DEPENDS buildtests )

=== debian/changelog ===
libgdf (0.1.2-2build3) trusty; urgency=medium

  * Rebuild for octave 3.8.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 24 Feb 2014 18:25:45 +0000

libgdf (0.1.2-2build2) trusty; urgency=low

  * No change rebuild for Boost 1.54 transition.

 -- Dmitrijs Ledkovs <xnox@ubuntu.com>  Tue, 22 Oct 2013 15:37:45 +0100

libgdf (0.1.2-2build1) saucy; urgency=low

  * No change rebuild for Boost 1.53 transition.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Fri, 26 Apr 2013 19:18:42 +0100

libgdf (0.1.2-2) unstable; urgency=medium

  [ Yaroslav Halchenko ]
  * debian/rules:
    - "Manually" provide octave:Depends=octave if octave-depends is not
       present (Closes: #667827).  This solution (over just adding octave
       into Depends) is chosen for backportability to Debian squeeze
  * Above and below changes by Rafael (THANK YOU) to address FTBFS due
    to deprecation of octave-depends (Closes: #666894)

  [ Rafael Laboissiere ]
  * debian/rules:
    - Use directly the octave-config script in order to get the
      installation path for the *.mex files
  * debian/octave-gdf.docs: New debhelper file for installing the
    gdf_{reader,writer}.m files, which contain actually just the
    documentation for the *.mex files
  * debian/octave-gdf.examples: New debhelper file for installing the
    provided examples

 -- Yaroslav Halchenko <debian@onerussian.com>  Thu, 10 May 2012 09:16:11 -0400

libgdf (0.1.2-1) unstable; urgency=low

  * Fresh upstream snapshot
    - Fixes endianness issues
  * Dropping cherry-picked up_cp-ev, up_cp-ev-channel, up_cp-data-orientation

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 22 Feb 2012 21:01:50 -0500

=== debian/control ===
Source: libgdf
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: NeuroDebian Team <team@neuro.debian.net>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>, Michael Hanke <michael.hanke@gmail.com>
Build-Depends: debhelper (>= 7.0.50~), cmake (>= 2.8), help2man,
			   libboost-dev (>> 1.34.2~), libboost-filesystem-dev, libboost-program-options-dev, libboost-date-time-dev,
			   octave-pkg-dev (>= 0.5.7)
Standards-Version: 3.9.2
Section: libs
Homepage: http://sourceforge.net/projects/libgdf
Vcs-Browser: http://git.debian.org/?p=pkg-exppsy/libgdf.git
Vcs-Git: git://git.debian.org/git/pkg-exppsy/libgdf.git


Package: libgdf0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: IO library for the GDF (general dataformat for biosignals)
 GDF (General Dataformat for Biosignals) is intended to provide a generic
 storage for biosignals, such as EEG, ECG, MEG etc.
 .
 This package contains the shared library.


Package: libgdf0-dbg
Section: debug
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libgdf0 (= ${binary:Version})
Description: IO library for the GDF -- debug symbols
 GDF (General Dataformat for Biosignals) is intended to provide a generic
 storage for biosignals, such as EEG, ECG, MEG etc.
 .
 This package provides debug symbols.


Package: libgdf-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libgdf0 (= ${binary:Version})
Description: IO library for the GDF -- development library
 GDF (General Dataformat for Biosignals) is intended to provide a generic
 storage for biosignals, such as EEG, ECG, MEG etc.
 .
 This package provides the header files and static library.


Package: gdf-tools
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: IO library for the GDF -- helper tools
 GDF (General Dataformat for Biosignals) is intended to provide a generic
 storage for biosignals, such as EEG, ECG, MEG etc.
 .
 This package provides the tool shipped with the library
 (gdf_merger).


Package: octave-gdf
Section: science
Architecture: any
Depends: ${octave:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: IO library for the GDF -- Octave interface
 GDF (General Dataformat for Biosignals) is intended to provide a generic
 storage for biosignals, such as EEG, ECG, MEG etc.
 .
 This package provides Octave bindings for libgdf.


Package: matlab-gdf
Section: contrib/science
Architecture: all
Depends: libgdf-dev (>= ${source:Version}), matlab-support, ${misc:Depends}
Description: IO library for the GDF -- Matlab interface
 GDF (General Dataformat for Biosignals) is intended to provide a generic
 storage for biosignals, such as EEG, ECG, MEG etc.
 .
 This package builds Matlab bindings for GDF at installation
 time. Note that this package depends on Matlab -- a commercial
 software that needs to be obtain and installed separately.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export LDFLAGS = -Wl,--as-needed

UVER = $(shell LC_ALL=C dpkg-parsechangelog | grep '^Version:' | cut -d ' ' -f 2,2 | cut -d '-' -f 1,1)
H2MVER = $(shell help2man --version | head -1 | sed -e 's/.* //g')

DEB_CMAKE_EXTRA_FLAGS = \
	-DBUILD_SHARED_LIBS:BOOL=ON \
	-DBUILD_TESTING:BOOL=ON

# get octave paths (have to build-depend on liboctave-dev)
# which is dependent upon by octave-pkg-dev
OCTDIR=$(shell octave-config --print LOCALOCTFILEDIR)

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		$(DEB_CMAKE_EXTRA_FLAGS)

override_dh_auto_build:
	dh_auto_build

	: # Build quick and dirty manpage whenever recent help2man is available
	if dpkg --compare-versions $(H2MVER) ge 1.37.1; then \
	  LD_LIBRARY_PATH=$$(/bin/ls -d $$PWD/obj-*)/libgdf \
		help2man --no-info -S libGDF -s 1 --version-string=$(UVER) \
		-n "Merge multiple GDF files" \
		*/tools/gdf_merger/gdf_merger >| gdf_merger.1; \
	else \
		touch gdf_merger.1; \
	fi

	: # Build Octave bindings
	cd matlab; \
	 for f in *.cpp; do \
		mkoctfile --mex $$f -I../libgdf/include -L$$(/bin/ls -d $$PWD/../obj-*)/libgdf -lGDF; \
	 done


override_dh_auto_install:
	dh_auto_install
	: # Install Octave bindings
	dh_install -poctave-gdf matlab/*.mex $(OCTDIR)/gdf
	[ -e /usr/bin/octave-depends ] \
	&& octave-depends -poctave-gdf \
	|| echo 'octave:Depends=octave (>= 3.4.3-1~)' >> debian/octave-gdf.substvars


override_dh_strip:
	dh_strip --dbg-package=libgdf0-dbg

override_dh_clean:
	dh_clean
	rm -f gdf_merger.1
	-cd matlab; rm *.mex *.o

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3
opts=filenamemangle=s/-source// \
    http://sf.net/libgdf/libgdf-(.*)-source\.tar\.gz

## libgdf 0.1.3

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 2.8 )
#project( GDF )

option( BUILD_TESTING "Build tests" OFF )

if( WIN32 )
	set( BUILD_SHARED_LIBS false CACHE BOOL "Whether we shall build shared or dynamic libraries." )
	option( BUILD_PYTHON_MODULES "Build python modules" OFF )
else( WIN32 )
	set( BUILD_SHARED_LIBS true CACHE BOOL "Whether we shall build shared or dynamic libraries." )
	option( BUILD_PYTHON_MODULES "Build python modules" OFF )
endif( WIN32 )

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake)

set( GDF_SOURCE_ROOT ${Project_SOURCE_DIR} )

add_subdirectory( libgdf )
add_subdirectory( tools )

# Make sure the version is in sync with
# libgdf/include/GDF/Version.h
set(GDF_VERSION "0.1.3")

# shared library API versioning (soversion) -- NOT the same as the release version
# it follows first number
string( REGEX MATCH "^[0-9]+" GDF_SHAREDLIB_SOVERSION ${GDF_VERSION})

set_target_properties(GDF PROPERTIES
	VERSION ${GDF_VERSION}
	SOVERSION ${GDF_SHAREDLIB_SOVERSION})

if (BUILD_TESTING)
	include( CTest )
	enable_testing( )
	add_subdirectory( test )
endif()

if( BUILD_PYTHON_MODULES )
	add_subdirectory( python )
endif()

=== libgdf/CMakeLists.txt ===
--- 
+++ 
@@ -7,6 +7,10 @@
         add_definitions( -Wall -Wextra -pedantic -Werror )
 elseif( WIN32 )
         add_definitions( -W3 )
+        # Default Windows installs go to "C:\Program files" which may fail
+        # if user has insufficient privelege. This if-clause puts the 
+        # compile results under GDF project folder.
+        set( CMAKE_INSTALL_PREFIX ${GDF_SOURCE_DIR} )
 endif( UNIX )
 
 #set( CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${GDF_SOURCE_DIR}/lib )
@@ -24,7 +28,9 @@
 	include/GDF/ChannelDataBase.h
 	include/GDF/ChannelData.h
 	include/GDF/Channel.h
+	include/GDF/EventConverter.h
 	include/GDF/EventHeader.h
+	include/GDF/EventDescriptor.h
 	include/GDF/Exceptions.h
 	include/GDF/GDFHeaderAccess.h
 	include/GDF/HeaderItem.h
@@ -33,18 +39,20 @@
 	include/GDF/pointerpool.h
 	include/GDF/Reader.h
 	include/GDF/RecordBuffer.h
+	include/GDF/RecordFullHandler.h
 	include/GDF/Record.h
 	include/GDF/SignalHeader.h
 	include/GDF/TagHeader.h
 	include/GDF/tools.h
 	include/GDF/Types.h
+	include/GDF/Version.h
 	include/GDF/Writer.h
-        include/GDF/EventConverter.h
 )
 
 set( SOURCES
 	src/Channel.cpp
 	src/EventHeader.cpp
+	src/EventDescriptor.cpp
 	src/GDFHeaderAccess.cpp
 	src/MainHeader.cpp
 	src/Modifier.cpp
@@ -52,17 +60,28 @@
 	src/RecordBuffer.cpp
 	src/Record.cpp
 	src/SignalHeader.cpp
+	src/TagHeader.cpp
 	src/Types.cpp
 	src/Writer.cpp
-        src/EventConverter.cpp
+	src/EventConverter.cpp
 )
 
 add_library( GDF ${HEADERS} ${SOURCES} ${Boost_LIBRARIES} )
 
-INSTALL( FILES ${HEADERS} DESTINATION include/GDF )
-INSTALL( TARGETS GDF
+install( FILES ${HEADERS} DESTINATION include/GDF )
+
+if( MSVC )
+        install( FILES ${PROJECT_BINARY_DIR}/Debug/gdf.pdb
+                DESTINATION lib
+                CONFIGURATIONS Debug
+                )
+endif( MSVC )
+
+install( TARGETS GDF
 	RUNTIME DESTINATION bin
 	LIBRARY DESTINATION lib
 	ARCHIVE DESTINATION lib
 )
 
+
+

=== python/CMakeLists.txt ===

#set( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_LIST_DIR}/cmake )

find_package( Cython REQUIRED )
find_package( PythonLibs REQUIRED )
#find_package( Boost REQUIRED COMPONENTS system thread )

set( cython_source_path ${CMAKE_CURRENT_SOURCE_DIR} )
set( cython_target_path ${CMAKE_CURRENT_BINARY_DIR} )
set( cython_libname pylibgdf )

set( cython_pyx ${cython_source_path}/${cython_libname}.pyx )
set( cython_cpp ${cython_target_path}/${cython_libname}.cpp )

add_custom_command(
  OUTPUT ${cython_cpp}
  COMMAND ${CYTHON_EXECUTABLE} --cplus -o ${cython_cpp} ${cython_pyx} 
  DEPENDS ${cython_pyx}
)

include_directories(
        ../libgdf/include
  ${PYTHON_INCLUDE_DIRS}
)

add_library( ${cython_libname} MODULE ${cython_cpp} )
target_link_libraries( ${cython_libname} GDF ) 

set_target_properties( ${cython_libname} PROPERTIES PREFIX "" )

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -36,6 +36,14 @@
 target_link_libraries( testRWConsistency ${Boost_LIBRARIES} GDF )
 add_test( NAME testRWConsistency COMMAND testRWConsistency )
 
+add_executable( testSparseSampling testSparseSampling.cpp )
+target_link_libraries( testSparseSampling ${Boost_LIBRARIES} GDF )
+add_test( NAME testSparseSampling COMMAND testSparseSampling )
+
+add_executable( testHeader3 testHeader3.cpp )
+target_link_libraries( testHeader3 ${Boost_LIBRARIES} GDF )
+add_test( NAME testHeader3 COMMAND testHeader3 )
+
 add_executable( testDataTypes testDataTypes.cpp )
 target_link_libraries( testDataTypes ${Boost_LIBRARIES} GDF )
 add_test( NAME testDataTypes COMMAND testDataTypes )

=== tools/CMakeLists.txt ===
add_subdirectory( gdf_merger )

=== tools/gdf_merger/CMakeLists.txt ===
cmake_minimum_required( VERSION 2.8 )
project( gdf_merger )

if( UNIX )
	add_definitions( -Wall -Wextra -pedantic -Werror -fPIC)
elseif( MINGW )
	add_definitions( -Wall -Wextra -pedantic -Werror )
elseif( WIN32 )
	add_definitions( -W3 )
endif( UNIX )

if( WIN32 )
	set(Boost_USE_STATIC_LIBS        ON)
	set(Boost_USE_MULTITHREADED      ON)
	set(Boost_USE_STATIC_RUNTIME    OFF)
endif( WIN32 )
find_package( Boost COMPONENTS program_options filesystem system )

include_directories(
	../../libgdf/include
	${Boost_INCLUDE_DIR}
)

set( HEADERS 
	gdfmerger.h
)

set( SOURCES
	gdfmerger.cpp
	main.cpp
)

#message( ${Boost_LIBRARIES}  )
add_executable( gdf_merger ${HEADERS} ${SOURCES} )
target_link_libraries( gdf_merger ${Boost_LIBRARIES} GDF)	

INSTALL( TARGETS gdf_merger
	RUNTIME DESTINATION bin
	LIBRARY DESTINATION lib
	ARCHIVE DESTINATION lib
)

=== debian/changelog ===
libgdf (0.1.3-13) unstable; urgency=medium

  * Team upload.
  * Fix build with CMake 4
    Closes: #1113154
  * debputy lint --auto-fix (routine-update)

 -- Andreas Tille <tille@debian.org>  Sat, 18 Oct 2025 21:29:35 +0200

libgdf (0.1.3-12) unstable; urgency=medium

  * d/copyright: Accentuate my family name
  * Override dh_shlibdeps for finding Octave's private library liboctmex.
    This is necessary for having the package building correctly against
    Octave 10. (Closes: #1114633)
  * d/control:
    + Bump Standards-Version to 4.7.2 (no changes needed)
    + Drop “Rules-Requires-Root: no”, which is now the default
  * d/watch: Convert to version 5
  * d/libgdf0t64.lintian-overrides: Drop unused Lintian override for
    package-name-doesnt-match-sonames

 -- Rafael Laboissière <rafael@debian.org>  Fri, 12 Sep 2025 15:05:23 -0300

libgdf (0.1.3-11.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062310

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 12:14:09 +0000

libgdf (0.1.3-11) unstable; urgency=medium

  * Team upload.
  * Move package to Debian Med team
  * Remove debian/blends
  * Remove debian/gbp.conf
  * Standards-Version: 4.6.0 (routine-update)
  * Remove old boilerplate from debian/rules (routine-update)
  * Add salsa-ci file (routine-update)

 -- Andreas Tille <tille@debian.org>  Mon, 15 Nov 2021 13:39:09 +0100

libgdf (0.1.3-10) unstable; urgency=medium

  * Upload to unstable (Closes: #984105)
  * Use d/clean instead of override_dh_clean target in d/rules
  * d/rules: Use execute_after_dh_* targets instead of override_dh_*

 -- Rafael Laboissière <rafael@debian.org>  Sun, 15 Aug 2021 05:50:01 -0300

libgdf (0.1.3-9) experimental; urgency=medium

  * d/p/compile-with-g++-11.patch: New patch (Closes: #984105)

 -- Rafael Laboissière <rafael@debian.org>  Wed, 07 Jul 2021 08:17:17 -0300

libgdf (0.1.3-8) unstable; urgency=medium

  * d/p/check-system-endianness.patch: Adjust for
    architecture-independent usage of BOOST_ENDIAN_(BIG|LITTLE)_BYTE
    macros. Thanks to Giovanni Mascellani for the tip (see Bug#978612).

 -- Rafael Laboissière <rafael@debian.org>  Thu, 31 Dec 2020 08:02:51 -0300

libgdf (0.1.3-7) unstable; urgency=medium

  * d/p/check-system-endianness.patch: Update patch.
    This fixes the problem of detection of endianness on the s390x
    architecture, what was causing the FTBFS on that architecture.
    (Closes: #977357)

 -- Rafael Laboissière <rafael@debian.org>  Mon, 28 Dec 2020 19:58:39 -0300

libgdf (0.1.3-6) unstable; urgency=medium

  * Avoid FTBFS when building against boost 1.74. Thanks to Anton
    Gladky (Closes: #975443)
    + d/p/check-system-endianess.patch: New patch for replacing the
      deprecated macros BOOST_*_ENDIAN by BOOST_ENDIAN_*_BYTE.
    + d/control: Impose minimal version 1.55 build-dependency on
      libboost-dev.  The new BOOST_ENDIAN_*_BYTE macros were introduced
      in this version of Boost.

 -- Rafael Laboissière <rafael@debian.org>  Wed, 25 Nov 2020 13:30:37 -0300

libgdf (0.1.3-5) unstable; urgency=medium

  * d/p/disable-werror.patch: Set "Forwarded: not-needed"
  * d/control: Bump Standards-Version to 4.5.1 (no changes needed)
  * Install the libgdf.so* files in /usr/lib/<arch>/
    + d/libgdf{0,-dev}.install:
      - Convert to use dh-exec
      - Install files in /usr/lib/${DEB_HOST_MULTIARCH}
    + d/control:
      - Build-Depend on dh-exec
      - Declare package libgdf-dev as Architecture any
  * d/libgdf0.lintian-overrides: Override Lintian warning
    no-symbols-control-file

 -- Rafael Laboissière <rafael@debian.org>  Mon, 23 Nov 2020 12:38:41 -0300

libgdf (0.1.3-4) unstable; urgency=medium

  * Allow stderr in unit tests.
    This allows autopkgtest to pass with libboost 1.71, since messages
    regarding the deprecation of BOOST_*_ENDIAN BOOST_BYTE_ORDER are
    issued at compilation time.  This is a quick fix while waiting for the
    problem to be fixed upstream. (Closes: #962217)
  * d/control:
    + Bump debhelper compatibitlity level to 13
    + Standards-Version to 4.5.0 (no changes needed)
    + Make libgdf-dev Arch: all. The dependencies on libgdf0 are
      adjusted for using source:Version, accordingly.  Also, adjust
      the long description to reflect this change.
    + Add Rules-Requires-Root: no
  * d/u/metadata
    + Drop Name and Contact fields
    + Add Repository* and Bug-* fields
  * d/rules: Drop --as-needed linker flag

 -- Rafael Laboissière <rafael@debian.org>  Fri, 05 Jun 2020 09:08:52 -0300

libgdf (0.1.3-3) unstable; urgency=medium

  * d/t/control: Depend on the needed Boost libraries

 -- Rafael Laboissiere <rafael@debian.org>  Mon, 19 Aug 2019 09:38:04 -0300

libgdf (0.1.3-2) unstable; urgency=medium

  * d/t/control: Depend only on libgdf-dev instead of @
    The dependency on matlab-gdf, imposed by the @ tag was causing
    preventing the debian-ci to run the unit tests.

 -- Rafael Laboissiere <rafael@debian.org>  Sun, 18 Aug 2019 11:16:09 -0300

libgdf (0.1.3-1) unstable; urgency=medium

  * New upstream version 0.1.3
  * d/watch, d/control, d/copyright: Use new upstream URL (@ GitHub)
  * d/control:
    + Add myself to the list of Uploaders
    + Set Priority: optional instead of extra
    + Bump Standards-Version to 4.4.0
    + Update Vcs-* URLs, which are at salsa.d.o now
  * d/p/disable-werror.patch:
    + Refresh for new upstream version
    + Comply with the Patch Tagging Guidelines (aka DEP3)
      Also, gives credit to Juhani Numminen <juhaninumminen0@gmail.com>, who
      first proposed this patch in the context of Bug#853492.
    + Use the file name proposed by Juhani
  * d/copyright:
    + Reflect upstream changes
    + Add global definition for LGPL-3 license
    + Use correct URL in the Format field
    + Use Upstream-* fields
  * Bump to debhelper compat level 12.
    Build-depend on debhelper-compat instead of using d/compat (this later
    file is removed)


=== debian/control ===
Source: libgdf
Standards-Version: 4.7.2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders:
 Yaroslav Halchenko <debian@onerussian.com>,
 Michael Hanke <michael.hanke@gmail.com>,
 Rafael Laboissière <rafael@debian.org>,
Section: libs
Priority: optional
Build-Depends:
 dpkg-dev (>= 1.22.5),
 cmake,
 debhelper-compat (= 13),
 dh-exec,
 dh-octave,
 help2man,
 libboost-date-time-dev,
 libboost-dev,
 libboost-filesystem-dev,
 libboost-program-options-dev,
Vcs-Browser: https://salsa.debian.org/med-team/libgdf
Vcs-Git: https://salsa.debian.org/med-team/libgdf.git
Homepage: https://github.com/mbillingr/libgdf

Package: libgdf0t64
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Breaks:
 libgdf0 (<< ${source:Version}),
Provides:
 ${t64:Provides},
Replaces:
 libgdf0,
Description: IO library for the GDF (general dataformat for biosignals)
 GDF (General Dataformat for Biosignals) is intended to provide a generic
 storage for biosignals, such as EEG, ECG, MEG etc.
 .
 This package contains the shared library.

Package: libgdf-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 ${misc:Depends},
 libgdf0t64 (>= ${source:Version}),
 libgdf0t64 (<< ${source:Version}.1~),
Description: IO library for the GDF -- development library
 GDF (General Dataformat for Biosignals) is intended to provide a generic
 storage for biosignals, such as EEG, ECG, MEG etc.
 .
 This package provides the header files.

Package: gdf-tools
Architecture: any
Section: utils
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: IO library for the GDF -- helper tools
 GDF (General Dataformat for Biosignals) is intended to provide a generic
 storage for biosignals, such as EEG, ECG, MEG etc.
 .
 This package provides the tool shipped with the library
 (gdf_merger).

Package: octave-gdf
Architecture: any
Multi-Arch: same
Section: science
Depends:
 ${octave:Depends},
 ${shlibs:Depends},
 ${misc:Depends},
Description: IO library for the GDF -- Octave interface
 GDF (General Dataformat for Biosignals) is intended to provide a generic
 storage for biosignals, such as EEG, ECG, MEG etc.
 .
 This package provides Octave bindings for libgdf.

Package: matlab-gdf
Architecture: all
Section: contrib/science
Depends:
 libgdf-dev (>= ${source:Version}),
 matlab-support,
 ${misc:Depends},
Description: IO library for the GDF -- Matlab interface
 GDF (General Dataformat for Biosignals) is intended to provide a generic
 storage for biosignals, such as EEG, ECG, MEG etc.
 .
 This package builds Matlab bindings for GDF at installation
 time. Note that this package depends on Matlab -- a commercial
 software that needs to be obtain and installed separately.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk

UVER = $(DEB_VERSION_UPSTREAM)
H2MVER = $(shell help2man --version | head -1 | sed -e 's/.* //g')

DEB_CMAKE_EXTRA_FLAGS = \
	-DBUILD_SHARED_LIBS:BOOL=ON \
	-DBUILD_TESTING:BOOL=ON \
	-DCMAKE_POLICY_VERSION_MINIMUM=3.5

# get octave paths (have to build-depend on liboctave-dev)
# which is dependent upon by dh-octave
OCTDIR=$(shell octave-config --print LOCALOCTFILEDIR)

# Use hardening options
# Taken from https://wiki.debian.org/Hardening#Notes_for_packages_using_CMake
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

# Define this variable to use in % and override_dh_shlibdeps targets
dh_options = --buildsystem=cmake --no-parallel

%:
	dh $@ $(dh_options)

override_dh_auto_configure:
	dh_auto_configure -- \
		$(DEB_CMAKE_EXTRA_FLAGS)

execute_after_dh_auto_build:
	: # Build quick and dirty manpage whenever recent help2man is available
	if dpkg --compare-versions $(H2MVER) ge 1.37.1; then \
	  LD_LIBRARY_PATH=$$(/bin/ls -d $$PWD/obj-*)/libgdf \
		help2man --no-info -S libGDF -s 1 --version-string=$(UVER) \
		-n "Merge multiple GDF files" \
		*/tools/gdf_merger/gdf_merger >| gdf_merger.1; \
	else \
		touch gdf_merger.1; \
	fi

	: # Build Octave bindings
	cd matlab; \
	 for f in *.cpp; do \
		mkoctfile --mex $$f -I../libgdf/include -L$$(/bin/ls -d $$PWD/../obj-*)/libgdf -lGDF; \
	 done

execute_after_dh_auto_install:
	: # Install Octave bindings
	chmod -x matlab/*.mex
	dh_install -poctave-gdf matlab/*.mex $(OCTDIR)/gdf
	dh_octave_substvar -poctave-gdf

override_dh_shlibdeps:
	dh_shlibdeps $(dh_options:%=-O%) -l$(shell octave-config -p OCTLIBDIR)

=== debian/tests/control ===
Tests: compile-and-run-tests
Depends: libgdf-dev, libboost-date-time-dev, libboost-dev, libboost-filesystem-dev, libboost-program-options-dev, g++, libc6-dev
Restrictions: allow-stderr

=== debian/watch ===
Version: 5

Source: https://github.com/mbillingr/libgdf/tags
Matching-Pattern: (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
